/*
       FILE: EXTEND.INC
   DISCRIPT: extension Z80 command system

     TARGET: ZXASM
     AUTHOR: Screw /CM/OHG
*/



/***************************************************************************
    'LD':      load 16 bits register from 16 bits register
                 LD hl/de/bc/ix/iy , hl/de/bc/ix/iy
***************************************************************************/



LD macro arg1,arg2

   IF LO(arg1) != HI(arg1)
    IF LO(arg2) != HI(arg2)
     IF arg1 != arg2
     // arg1 && arg2 size are 16 bits
     //   arg1 <> arg2

      ld lo(arg1),lo(arg2)
      ld hi(arg1),hi(arg2)
    ELSE
     IF arg1 == SP        // trying to SP loading
      _@SP_LOADER_TO_ arg1,arg2
    ELSE
     IF arg2 == SP
      _@SP_LOADER_FROM arg1,arg2
    ELSE
      error
     endm


                         // helper for LD
                         _@SP_LOADER_FROM macro arg1,arg2

                            IF LO(arg1) == HI(arg1)
                              error
                            ELSE
                             IF arg1 != BC
                              IF arg1 != DE
                               ld arg1,0
                               add arg1,sp
                            ELSE
                               ld (@MODIFY+1),hl
                                  _@SP_LOADER_FROM hl,sp
                                ld arg1,hl
                               @MODIFY: ld hl,0
                            endm

/***************************************************************************
     'EX':   EXCHANGE two 8/16 bits registers
              EX hl/de/bc/ix/iy , hl/de/bc/ix/iy
              EX h/l/d/e/b/c/xh/xl/yh/yl , h/l/d/e/b/c/xh/xl/yh/yl
***************************************************************************/
EX macro arg1, arg2

   IF LO(arg1) != HI(arg1)  // ।,  ॣ 16.
   // if arg's size are 16 bits
        push arg1
        ld arg1,arg2 // call macros LD (always)
   //      ld lo(arg1),lo(arg2)
  //       ld hi(arg1),hi(arg2)
        pop arg2
   ELSE
    IF arg1 != A
     IF arg2 != A
   // if arg's size are 8 bits
        push af
         ld a,arg1
         ld arg1,arg2
         ld arg2,a
        pop af
   ELSE
      error // syntax error generation
   endm

/***************************************************************************
    'SBC':  SUBTRACT with CARRY 16 bits register from 16 bits register
              SBC hl/de/bc/ix/iy , hl/de/bc/ix/iy
***************************************************************************/
SBC macro arg1,arg2  // SBC arg1,arg2
     IF arg2 != HL
      push hl
      push arg1
      pop hl
      sbc hl,arg2
      ex (sp),hl
      pop arg1
     ELSE
      ex arg1,arg2  // call macros EX (optional)
      sbc arg2,arg1
      ex arg1,arg2  // call macros EX (optional)
      endm

/***************************************************************************
    'SBC':  SUBTRACT 16 bits register from 16 bits register
              SBC hl/de/bc/ix/iy , hl/de/bc/ix/iy
***************************************************************************/
SUB macro arg1,arg2 // SUB arg1,arg2
     or a
     sbc arg1,arg2  // call macros SBC (optional)
     endm


     org 32750      test.c

start:
//     ALIGN 256
//     db 'TESTING PAGING CARRY'
//     #include gf.inc
       ld bc,de
       nop
       ex bc,hl
       nop
       ld sp,de

end:

#bin_save fuck.c start, end-start